package com.fp.persistence.pgeneral.gene;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENEOFFICER*/
@Entity(name="TgeneOfficer")
@Table(name="TGENEOFFICER")
public class TgeneOfficer extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneOfficer
*/
@EmbeddedId
private TgeneOfficerKey pk;
/**Contructor por defecto*/
public TgeneOfficer(){
}
/**Contructor de TgeneOfficer
@param pPk Clave Primaria del entity
*/
public TgeneOfficer(TgeneOfficerKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneOfficer
*/
public static TgeneOfficer find(EntityManager pEntityManager,TgeneOfficerKey pKey) throws Exception{
    TgeneOfficer obj = pEntityManager.find(TgeneOfficer.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneOfficer
@return El objeto que referencia a la Clave primaria de TgeneOfficer
*/
public TgeneOfficerKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneOfficer
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneOfficer
*/
public void setPk(TgeneOfficerKey pPk){
  pk=pPk;
}
public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneOfficer))return false;
    TgeneOfficer that = (TgeneOfficer) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneOfficer
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneOfficer
*/
public Object createInstance(){
 TgeneOfficer instance=new TgeneOfficer();	
 instance.setPk(new TgeneOfficerKey());
 return instance;
}
/**Clona la entidad TgeneOfficer
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneOfficer p=(TgeneOfficer)this.clone();
  p.setPk((TgeneOfficerKey)this.pk.cloneMe());
  return p;
}
}
